package com.maroontress.madangler.client;

import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.Hyperlink;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Widget;

/**
   ץȰΥơ֥Ǥ

   ץȤξǤ⡢ơ֥ϥơ֥إåȿץ
   ȺΥ󥯤ޤߤޤ
*/
public class ProjectTable extends FlexTable {

    /** ơ֥Υեޥå */
    private FlexTable.FlexCellFormatter fomatter;

    /** ơ֥ѲΤꥹ */
    private ProjectTableListener tableListener;

    /**
       ץȤΥơ֥ޤ
    */
    public ProjectTable() {
	setWidth("100%");
	insertRow(0);
	setText(0, 0, "Project ID");
	setText(0, 1, "Description");
	setText(0, 2, "Config");
	setText(0, 3, "Delete");
	fomatter = getFlexCellFormatter();
	fomatter.setStyleName(0, 0, "projHeader");
        fomatter.setStyleName(0, 1, "projHeader");
        fomatter.setStyleName(0, 2, "projHeader");
        fomatter.setStyleName(0, 3, "projHeader");

	Link link = new Link();
	link.addParameter("type", "newProject");
	Hyperlink newProj = new Hyperlink("New Project", link.encode());

	insertRow(1);
	setWidget(1, 0, newProj);
        fomatter.setStyleName(1, 0, "proj");
    }

    /**
       ꥹʤꤷޤ

       @param listener ץȥơ֥ꥹ
    */
    public void setProjectTableListener(final ProjectTableListener listener) {
	tableListener = listener;
    }

    /**
       ơ֥˥ץȤɲäޤ

       @param name ץID
       @param desc ץȤ
    */
    public void addProject(final String name, final String desc) {
	Link link = new Link();
	link.addParameter("id", name);

	link.addParameter("type", "buildList");
	Hyperlink proj = new Hyperlink(name, link.encode());

	link.addParameter("type", "config");
	Hyperlink edit = new Hyperlink("Edit", link.encode());

	HTML delete = new HTML("Delete");
	delete.setStyleName("linkHTML");
	delete.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		if (tableListener == null) {
		    return;
		}
		tableListener.deleteProject(ProjectTable.this, name);
	    }
	});
	int row = getRowCount() - 1;
	insertRow(row);
        setWidget(row, 0, proj);
        setText(row, 1, desc);
        setWidget(row, 2, edit);
        setWidget(row, 3, delete);
        fomatter.setStyleName(row, 0, "proj");
        fomatter.setStyleName(row, 1, "proj");
        fomatter.setStyleName(row, 2, "proj");
        fomatter.setStyleName(row, 3, "proj");
    }

    /**
       ơ֥ˤޤ
    */
    public void clearProject() {
	while (getRowCount() > 2) {
	    removeRow(1);
	}
    }
}
