#ifndef BuildLog_H
#define BuildLog_H

#include <sys/types.h>

struct Serial;
struct BuildLog;

struct BuildLog * BuildLog_create(const char *projectID);
void BuildLog_free(struct BuildLog *bl);
void BuildLog_getBasePath(struct BuildLog *bl, struct Serial *serial,
			  /*@out@*/ char *path, size_t pathLen);
void BuildLog_getPath(struct BuildLog *bl, struct Serial *serial,
		      int platformCode, /*@out@*/ char *path, size_t pathLen);

#endif
